<template>
    <div class="app-container">
        <el-row :gutter="20" type="flex" justify="center" align="middle">
            <el-col :lg="23" :md="23" :sm="24" align="middle" class="paper">
                <div class="filter-container">
                    <el-row :gutter="20">
                        <el-col :span="6" class="text-align-left">
                            <h3>Organization</h3>
                        </el-col>
                        <el-col :span="18">
                            <el-row :gutter="20">
                                <el-col :lg="14" :md="14" :sm="24">
                                    <el-input 
                                        prop="keyword" 
                                        v-model="filter.keyword" 
                                        ref="keyword" 
                                        name="keyword" 
                                        placeholder="Organization's name, code" 
                                        size="large" 
                                        class="filter-item width-100" 
                                        clearable 
                                        @keyup.enter.native="getOrganizations(1, false)" 
                                        @clear="getOrganizations(1, false)"/>
                                </el-col>
                                <el-col :lg="5" :md="5" :sm="24">
                                    <el-button @click="getOrganizations(1, false)" size="small" type="primary" class="filter-item width-100" style="font-size:14px;">
                                        <i class="ion-ios-search"></i> Search
                                    </el-button>
                                </el-col>
                                <el-col :lg="5" :md="5" :sm="24">
                                    <el-button size="small" type="success" class="filter-item width-100" style="font-size:14px;" @click="handleAddNew">
                                        <i class="ion-ios-add-circle"></i> Add
                                    </el-button>
                                </el-col>
                            </el-row>
                        </el-col>
                    </el-row>
                </div>
                <el-table v-loading="tableLoading" :data="organizations" style="width: 100%" :height="tableHeight()" fit highlight-current-row v-infinite-scroll="loadMore">
                    <el-table-column
                        fixed="left"
                        label="Code"
                        width="150">
                        <template slot-scope="scope">
                            <span style="color:#3E89FA;">{{ scope.row.code }}</span>
                        </template>
                    </el-table-column>
                    <el-table-column                        
                        label="Name"
                        width="300">
                        <template slot-scope="scope">
                            <span>{{ convertAmpersand(scope.row.name).capitalize() }}</span>
                        </template>
                    </el-table-column>
                    <el-table-column
                        label="Description"
                        width="300">
                        <template slot-scope="scope">
                            <span>{{ convertAmpersand(scope.row.description) }}</span>
                        </template>
                    </el-table-column>
                    <el-table-column
                        label="Cost Center"
                        width="150">
                        <template slot-scope="scope">
                            {{ scope.row.cost_center }}
                        </template>
                    </el-table-column>                    
                    <el-table-column
                        label="Last Updated"
                        width="150">
                        <template slot-scope="scope">
                            {{ dateFormat(scope.row.updated) }}
                        </template>
                    </el-table-column>
                    <el-table-column
                        fixed="right"
                        label="Action"
                        min-width="200">
                        <template slot-scope="{row}">
                            <el-button v-permission="[row, 'organization', 'viewother']" type="text" @click="handleEdit(row)">Edit</el-button>
                            <el-button v-permission="[row, 'organization', 'deleteother']" type="text" class="text-danger" @click="handleDelete(row)">Delete</el-button>
                        </template>
                    </el-table-column>
                </el-table>

                <el-dialog v-loading="dialogLoading" :title="dialogTitle[dialogStatus]" :visible.sync="showDialog" width="40%" :show-close="false" @closed="resetForm">
                    <el-form ref="organizationForm" :model="organizationForm" :rules="organizationRules">
                        <aside>
                            <el-alert type="info" description="Add or edit company organization info" :closable=false show-icon></el-alert>
                        </aside>
                        <el-row :gutter="20">
                            <el-col :lg="12" :md="12" :sm="24">
                                <el-form-item label="Code" prop="code">
                                    <el-input ref="code" name="code" v-model="organizationForm.code" placeholder="Full name" autocomplete="off" maxlength="45" class="has-suffix" show-word-limit></el-input>
                                </el-form-item>
                            </el-col>
                            <el-col :lg="12" :md="12" :sm="24">
                                <el-form-item label="Name" prop="name">
                                    <el-input ref="name" name="name" v-model="organizationForm.name" placeholder="Permission name" autocomplete="off" maxlength="100" class="has-suffix" show-word-limit></el-input>
                                </el-form-item>
                            </el-col>
                        </el-row> 
                        <el-row :gutter="20">
                            <el-col :lg="12" :md="12" :sm="24">
                                <el-form-item label="Cost Center" prop="cost_center">
                                    <el-input ref="cost_center" name="cost_center" v-model="organizationForm.cost_center" placeholder="Full name" autocomplete="off" maxlength="25" class="has-suffix" show-word-limit></el-input>
                                </el-form-item>
                            </el-col>
                            <el-col :lg="12" :md="12" :sm="24">
                                <el-form-item label="Description" prop="description">
                                    <el-input ref="description" name="description" v-model="organizationForm.description" placeholder="Description" autocomplete="off" maxlength="255" class="has-suffix" show-word-limit></el-input>
                                </el-form-item>
                            </el-col>
                        </el-row>                         
                    </el-form>
                    <span slot="footer" class="dialog-footer">
                        <el-button @click="showDialog = false" size="medium"><i class="ion-ios-close-circle-outline"></i> Cancel</el-button>
                        <el-button v-permission="[null, 'organization', 'editother']" @click="handleSubmit" size="medium" type="success">
                            <i class="ion-ios-checkmark-circle"></i> {{ dialogTitle[dialogStatus] }}
                        </el-button>
                    </span>
                </el-dialog>
            </el-col>
        </el-row>
    </div>
</template>
<script>
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import { parseError, dateFormat, tableHeight, convertAmpersand } from '../../utils/index';
export default {
    name: 'Organizations',
    directives: {
        permission
    },
    data(){
        return{
            tableLoading: false,
            dialogLoading: false,
            showDialog: false,
            dialogStatus: '',
            dialogTitle: {
                edit: 'Edit Organization',
                add: 'Add New Organization'
            },
            filter: {
                keyword: ''
            },
            organizationForm: {
                id: null,
                code: '',
                name: '',
                cost_center: '',
                description: ''
            },
            organizationRules: {
                code: [{ 
                    required: true, message: 'Organization code is required', trigger: 'blur'
                }, {
                    max: 45, message: 'Organization code length 45 characters', trigger: 'blur'
                }, {
                    pattern: /^([a-zA-Z0-9]{1,45})$/, 
                    message: 'Only letters and numbers are allowed.', 
                    trigger: 'blur'
                }],
                name: [{ 
                    required: true, message: 'Organization name is required', trigger: 'blur'
                }, {
                    max: 100, message: 'Organization name length 100 characters', trigger: 'blur'
                }, {
                    pattern: /^([a-zA-Z0-9&\s]{1,100})$/, 
                    message: 'Only letters, numbers, ampersands and spaces are allowed.', 
                    trigger: 'blur'
                }],
                cost_center: [{ 
                    required: true, message: 'Organization cost center is required', trigger: 'blur'
                }, {
                    max: 25, message: 'Organization cost center length 25 characters', trigger: 'blur'
                }, {
                    pattern: /^([a-zA-Z0-9]{1,25})$/, 
                    message: 'Only letters and numbers are allowed.', 
                    trigger: 'blur'
                }],
                description: [{ 
                    max: 255, 
                    message: 'Description length maximum 255 characters', 
                    trigger: 'blur'
                }]
            },
        }
    },
    computed:{
        ...mapGetters('auth', ['user']),
        ...mapGetters('organization', [
            'organizations',
            'pagination'
        ])
    },
    created(){
        const self = this;

        self.getOrganizations(1, false);
    },
    methods: {
        dateFormat,
        tableHeight,
        convertAmpersand,
        getOrganizations(page, loadmore){
            const self = this;

            self.tableLoading = true;

            let params = {
                page: page,
                perpage: 25,
                loadmore: loadmore,
                type: 'content'
            };

            if(self.filter.keyword.trim().length > 0){
                params.q = self.filter.keyword;
            }

            self.$store.dispatch('organization/getOrganizations', params).then(()=>{
                self.tableLoading = false;
            });
        },
        loadMore(){
            const self = this;
            
            if(self.pagination.has_next){    
                self.getOrganizations(self.pagination.page + 1, true);
            }
        },
        handleAddNew(){
            const self = this;
            self.dialogStatus = 'add';
            self.showDialog = true;          
            self.$nextTick(() => {
                self.$refs['organizationForm'].clearValidate();
            });
        },
        handleEdit(organization){
            const self = this;
            self.dialogStatus = 'edit';
            self.showDialog = true;

            self.organizationForm.id = organization.id;
            self.organizationForm.code = organization.code.toUpperCase();
            self.organizationForm.name = convertAmpersand(organization.name).capitalize();
            self.organizationForm.cost_center = organization.cost_center.toUpperCase();
            self.organizationForm.description = convertAmpersand(organization.description).capitalize();

            self.$nextTick(() => {
                this.$refs['organizationForm'].clearValidate();
            });
        },
        handleDelete(organization){
            const self = this;

            self.$confirm('You are about to delete this organization. This operation will affecting some modules become malfunction and this operation cannot be undone. Are you sure?', 'Warning', {
                confirmButtonText: 'Yes, I\'m Sure',
                cancelButtonText: 'Cancel'
            }).then(()=>{
                self.tableLoading = true;
                self.$store.dispatch('organization/deleteOrganization', {
                    id: organization.id
                }).then((response) => {
                    self.tableLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        self.$message.error({
                            message: error.messages
                        });
                    }else{
                        self.$message.success({
                            message: response.message
                        });
                    }
                });
            });
        },
        handleSubmit(){
            const self = this;

            self.$refs.organizationForm.validate((valid)=>{
                if(valid){
                    self.dialogLoading = true;

                    let action = 'organization/addOrganization';
                    let params = {
                        code: self.organizationForm.code.toUpperCase(),
                        name: self.organizationForm.name.capitalize(),
                        cost_center: self.organizationForm.cost_center.toUpperCase(),
                        description: self.organizationForm.description.capitalize()
                    };

                    if(self.dialogStatus == 'edit'){
                        action = 'organization/editOrganization';
                        params.id = self.organizationForm.id;
                    }

                    self.$store.dispatch(action, params).then((response)=>{
                        self.dialogLoading = false;

                        if('errors' in response){
                            let error = parseError(response.errors);
                            self.$message.error({
                                message: error.messages
                            });
                        }else{
                            self.showDialog = false;
                            self.$message.success({
                                message: response.message
                            });

                            self.resetForm();
                        }
                    });
                }else{
                    return false;
                }
            });
        },
        resetForm() {
            const self = this;

            self.organizationForm = {
                id: null,
                code: '',
                name: '',
                cost_center: '',
                description: ''
            };
        },
    }
}
</script>